//****************************************************************
//  User Information                           G. Danen  08-Nov-98
//
//  Copyright (c) 1995-1999 by GeCe Ventures; all rights reserved.
//
//  Requires MBBS developers kit to recompile
//****************************************************************


// allow for name format like in [custom] for all other reports
// allow day range "last 60 days" **
// allow specific date range "01-jan-95 to 31-mar-95" **
// ** allow a NOT option to select OUTSIDE the range...


#include"gcomm.h"
#include"majorbbs.h"
#include"message.h"
#include"danenlib.h"


#define pgVERS_ "V3.10"
#define pgTITL_ "User Information for The Major BBS/WorldGroup"
#define pgCOPR_ "1995-1999"
#define inHOUSEuse  0


#define szUNAME (UIDSIZ-1)                      // maximum size of user name
#define szCLASS (KEYSIZ-1)                      // maximum size of class


#define MAXFOLKS 500
char    person[MAXFOLKS+1][81], one_person[sizeof(person[0])*2] ;
int     person_end=0, this_person=0, look_prev=1, look_next=28 ;

BOOL    ynRepStd=FALSE, ynRepDet=FALSE, ynRepCsv=FALSE, ynRepBdt=FALSE,
        ynRepCus=FALSE, ynRepPurge=FALSE, ynRepStats=FALSE,
        ynProcess=TRUE, ynPassword=FALSE, ynCreditInfo=FALSE, ynSort=TRUE,
        ynANSI=FALSE, ynBDcls=FALSE, ynCusBirth=FALSE, ynCusAge=FALSE,
        ynCusCrDate=FALSE, ynCusCrDays=FALSE, ynCusLgDate=FALSE,
        ynCusLgDays=FALSE, ynCusClass=FALSE, ynCusPhone=FALSE,
        ynPurShowprotected=TRUE ;

int     rnCusName=0, rnCusBirth=0, rnCusAge=0, rnCusCrDate=0, rnCusCrDays=0,
        rnCusLgDate=0, rnCusLgDays=0, rnCusClass=0, rnCusPhone=0, rnDummy ;
char    *tblCusFld[31], *tblCusHdr[31] ;
char    *tblField[] = { "", "name", "birth", "age", "crdate", "crdays", "lgdate", "lgdays", "class", "phone", "" };

int     iCusNameFmt,  iCusNameSiz=30,
        iCusBDateFmt, iCusBDateSiz,
        iCusCDateFmt, iCusCDateSiz,
        iCusLDateFmt, iCusLDateSiz,
        iCusClassSiz=szCLASS, iCusPhoneSiz=20,
        iCusAgeSiz, iCusCDaysSiz, iCusLDaysSiz ;

//      Report files: std (wide), details, csv, birthdays, stats
char    repStd[256], repDet[256], repCsv[256], repBdt[256], repCus[256],
        repPurge[256], repStats[256], iniName[256] ;
FILE    *fStd, *fDet, *fCsv, *fBdt, *fCus, *fPur, *fStat ;

BTVFILE *btvUsr ;               // btrieve file pointer
BTVFILE *genbb  ;               // generic user data file btrieve file ptr - don't change name "genbb"
struct  usracc acct ;           // user account structure
struct  usracc *usaptr ;        // ptr to current user's usracc entry

long    numact=0, numpai=0, numale=0, numfem=0, useavl=0, numMaster=0,
        numProt=0, numSusp=0, numKillTag=0, numInvis=0, nymd, this_year,
        next_year, today_days, prevbd, nextbd ;
int     ny, nm, nd, moda1, moda2, age, nPurDays=7, nPurTotal=0, iCsvDateFmt=12,
        iRepDateFmt=1, iCsvDateSiz=0, iRepDateSiz=0 ;
char    *line = "--------------------------------------------------------------------------------" ;
char    *Line = "" ;
char    sAge[6], dt1[21], dt2[21], dt3[21], BD1[21], BD2[21], BD3[51],
        ansiClrEol[]="\033[K", ansiReset[]="\033[0m", ansiColor[13],
        ansiBDhappyColor[13], ansiBDdateColor[13], ansiBDnameColor[13],
        sPurClass[szCLASS+1], sClassGenExclude[szCLASS+1],
        sClassGenInclude[szCLASS+1] ;


#include"danenlib.c"


int     what_ansi_color( STRING sFG, STRING sBG, STRING sOut )
{
    int f, b, h=0 ;
    static int color[] = { 30, 34, 32, 36, 31, 35, 33, 37 };

    f = ut_color_code( sFG );
    b = ut_color_code( sBG );
    if ( f==ERROR || b==ERROR )
        return( ERROR );
    if ( f > 7 )
    {
        f = f % 8 ;
        h = 1 ;
    }
    if ( b > 7 )
    {
        b = b % 8 ;
        h = 1 ;
    }
    if ( (f==b) && h==0 )                       // invisible!
        return( ERROR );

    sprintf( sOut, "\033[%d;%d;%dm", h, color[f], color[b]+10 );

    return( OK );
}


int     dt_calculate_age( char *sDate, char sAge[], long *bdprev, long *bdnext ) // calc age from "MM/DD/YY"
{                                               // returns -1 if invalid
    int         by, bm, bd, err ;
    long        bymd, nextBdate ;

    *bdprev = *bdnext = 0 ;

    bymd = dt_decode_str( sDate );
    err = DateSplit( bymd, &by, &bm, &bd );
    if ( bymd == ERROR || err == ERROR )
    {
        strcpy( sAge, "n/a" );
        return( ERROR );
    }

    moda2 = bm*100 + bd ;
    if ( moda1 > moda2 )
    {
        nextBdate = next_year + moda2 ;
        age = ny - by ;
    }
    else
    {
        nextBdate = this_year + moda2 ;
        age = ny - by - 1 ;
    }

    sprintf( sAge, "%3d", age );

    *bdnext = DaysBetween( nymd, nextBdate );
    *bdprev = DaysBetween( nymd, nextBdate-10000L );

    return( age );
}


BOOL    parse_ini_TF( STRING section, STRING key )
{
    char        ini[256] ;

    fl_parse_ini( iniName, section, key, ini, &rnDummy );
    if ( ini[0]=='y' || ini[0]=='Y' || ini[0]=='1' ||
         ini[0]=='t' || ini[0]=='T' )
        return( TRUE );
    else
        return( FALSE );
}


BOOL    parse_ini_report( STRING name, STRING file )
{
    char        ini[256] ;

    *file = EOS ;
    if ( fl_parse_ini( iniName, "reports", name, ini, &rnDummy ) < 1 )
        return( FALSE );
    strcpy( file, ini );
    if ( strlen(ini) )
        return( TRUE );
    else
        return( FALSE );
}


int     parse_ini_date_format( STRING section, STRING key, int deflt, int *fldsize )
{
    char        ini[256] ;
    int         fmt = deflt ;

    *fldsize = 0 ;
    fl_parse_ini( iniName, section, key, ini, &rnDummy );
    if ( st_eq(ini, "ddmmmyy"    ) )   { fmt =  0;  goto finish_up; }
    if ( st_eq(ini, "dd-mmm-yy"  ) )   { fmt =  1;  goto finish_up; }
    if ( st_eq(ini, "dd.mmm.yyyy") )   { fmt =  2;  goto finish_up; }
    if ( st_eq(ini, "dd-mmm-yyyy") )   { fmt =  9;  goto finish_up; }
    if ( st_eq(ini, "mm/dd/yy"   ) )   { fmt = 11;  goto finish_up; }
    if ( st_eq(ini, "yyyymmdd"   ) )   { fmt = 12;  goto finish_up; }

finish_up:
    *fldsize = dt_format_size( fmt );
    return( fmt );
}


int     parse_ini_int( STRING section, STRING key, int *number, int nLow, int nHigh )
{
    char        ini[256] ;
    int         n ;

    fl_parse_ini( iniName, section, key, ini, &rnDummy );
    if ( ! strlen(ini) )
        return( -1 );

    if ( sscanf( ini, "%d", &n ) == 1 )
    {
        if ( INRANGE(n,nLow,nHigh) )
        {
            *number =  n ;
            return( 0 );
        }
    }
    return( -1 );
}


void    parse_ini_file( void )                  //~~~
{
    char        fg[80], bg[80] ;
    int         err ;

    if ( ! fl_exist( iniName ) )
    {
        fprintf( stderr, "\nInitialization (.ini) file %s is missing!\nCannot proceed.\a\n\n", iniName );
        exit( 99 );
    }

    ynPassword         = parse_ini_TF( "userlist" , "passwords"     );
    ynCreditInfo       = parse_ini_TF( "userlist" , "creditinfo"    );
    ynSort             = parse_ini_TF( "birthdate", "sort"          );
    ynPurShowprotected = parse_ini_TF( "purge"    , "showprotected" );

    ynRepCus   = parse_ini_report( "custom"   , repCus   );
    ynRepStd   = parse_ini_report( "standard" , repStd   );
    ynRepDet   = parse_ini_report( "detail"   , repDet   );
    ynRepCsv   = parse_ini_report( "csv"      , repCsv   );
    ynRepBdt   = parse_ini_report( "birthdate", repBdt   );
    ynRepPurge = parse_ini_report( "purge"    , repPurge );
    ynRepStats = parse_ini_report( "stats"    , repStats );

    iCsvDateFmt = parse_ini_date_format( "userlist", "csvdate", iCsvDateFmt, &iCsvDateSiz );
    iRepDateFmt = parse_ini_date_format( "userlist", "repdate", iRepDateFmt, &iRepDateSiz );

    parse_ini_int( "birthdate", "prev", &look_prev, 0, 10 );
    parse_ini_int( "birthdate", "next", &look_next, 1, 60 );
    parse_ini_int( "purge", "days", &nPurDays, 1, 90 );

    fl_parse_ini( iniName, "userlist", "exclude", sClassGenExclude, &rnDummy );
    strupr( sClassGenExclude );
    fl_parse_ini( iniName, "userlist", "include", sClassGenInclude, &rnDummy );
    strupr( sClassGenInclude );

    fl_parse_ini( iniName, "purge", "class", sPurClass, &rnDummy );
    strupr( sPurClass );

    fl_parse_ini( iniName, "birthdate", "format", fg, &rnDummy );
    if ( st_eq(fg, "ansi") )
        ynANSI = TRUE ;
    if ( ynANSI )
    {
        fprintf( stderr, "ANSI mode for birthday list\n" );
        ynBDcls = parse_ini_TF( "birthdate", "cls" );
        fl_parse_ini( iniName, "ansi", "fg", fg, &rnDummy );
        fl_parse_ini( iniName, "ansi", "bg", bg, &rnDummy );
        err = what_ansi_color( fg, bg, ansiColor );
        if ( err == ERROR )
            strcpy( ansiColor, "\033[0;31;47m" );

        fl_parse_ini( iniName, "birthdate", "fghappy", fg, &rnDummy );
        fl_parse_ini( iniName, "birthdate", "bghappy", bg, &rnDummy );
        err = what_ansi_color( fg, bg, ansiBDhappyColor );
        if ( err == ERROR )
            strcpy( ansiBDhappyColor, ansiColor );

        fl_parse_ini( iniName, "birthdate", "fgdate", fg, &rnDummy );
        fl_parse_ini( iniName, "birthdate", "bgdate", bg, &rnDummy );
        err = what_ansi_color( fg, bg, ansiBDdateColor );
        if ( err == ERROR )
            strcpy( ansiBDdateColor, ansiColor );

        fl_parse_ini( iniName, "birthdate", "fgname", fg, &rnDummy );
        fl_parse_ini( iniName, "birthdate", "bgname", bg, &rnDummy );
        err = what_ansi_color( fg, bg, ansiBDnameColor );
        if ( err == ERROR )
            strcpy( ansiBDnameColor, ansiColor );
    }
    if ( ynRepCus )                             // custom report
    {
        fl_parse_ini( iniName, "custom", "name", fg, &rnCusName ); // name format
        if ( st_eq(fg, "realname") )
            iCusNameFmt = 2 ;
        else
        if ( st_eq(fg, "realname+userid") )
            iCusNameFmt = 3 ;
        else
        if ( st_eq(fg, "userid+realname") )
            iCusNameFmt = 4 ;
        else
            iCusNameFmt = 1 ;                   // userid

        parse_ini_int( "custom", "namesize", &iCusNameSiz, 10, 60 );

        //  birth date
        iCusBDateFmt = parse_ini_date_format( "custom", "birth", -1, &iCusBDateSiz );
        if ( iCusBDateFmt == -1 )
        {
            ynCusBirth = FALSE ;
            iCusBDateSiz = 0 ;
        }
        else
        {
            fl_parse_ini( iniName, "custom", "birth", fg, &rnCusBirth ); // get position in file
            ynCusBirth = TRUE ;
        }

        //  date of account creation
        iCusCDateFmt = parse_ini_date_format( "custom", "createdate", -1, &iCusCDateSiz );
        if ( iCusCDateFmt == -1 )
        {
            ynCusCrDate = FALSE ;
            iCusCDateSiz = 0 ;
        }
        else
        {
            fl_parse_ini( iniName, "custom", "createdate", fg, &rnCusCrDate ); // get position in file
            ynCusCrDate = TRUE ;
        }

        //  date of last login
        iCusLDateFmt = parse_ini_date_format( "custom", "logindate", -1, &iCusLDateSiz );
        if ( iCusLDateFmt == -1 )
        {
            ynCusLgDate = FALSE ;
            iCusLDateSiz = 0 ;
        }
        else
        {
            fl_parse_ini( iniName, "custom", "logindate", fg, &rnCusLgDate ); // get position in file
            ynCusLgDate = TRUE ;
        }

        //  age
        fl_parse_ini( iniName, "custom", "age", fg, &rnCusAge );
        if ( parse_ini_int( "custom", "age", &iCusAgeSiz, 2, 10 ) == 0 )
            ynCusAge = TRUE ;
        else
            ynCusAge = FALSE ;

        //  days ago account created
        fl_parse_ini( iniName, "custom", "createdays", fg, &rnCusCrDays );
        if ( parse_ini_int( "custom", "createdays", &iCusCDaysSiz, 3, 10 ) == 0 )
            ynCusCrDays = TRUE ;
        else
            ynCusCrDays = FALSE ;

        //  days since last login
        fl_parse_ini( iniName, "custom", "logindays", fg, &rnCusLgDays );
        if ( parse_ini_int( "custom", "logindays", &iCusLDaysSiz, 3, 10 ) == 0 )             ynCusLgDays = TRUE ;
        else
            ynCusLgDays = FALSE ;

        ynCusClass = parse_ini_TF( "custom", "class" );
        if ( ynCusClass )
        {
            fl_parse_ini( iniName, "custom", "class", fg, &rnCusClass );
            parse_ini_int( "custom", "classize", &iCusClassSiz, 5, 20 );
        }

        ynCusPhone = parse_ini_TF( "custom", "phone" );
        if ( ynCusPhone )
        {
            fl_parse_ini( iniName, "custom", "phone", fg, &rnCusPhone );
            parse_ini_int( "custom", "phonesize", &iCusPhoneSiz, 8, 20 );
        }
    }
}


FILE    *open_file( BOOL *ok2open, FILE *f, STRING fname, STRING sDescr )
{
    if ( *ok2open )
    {
        strupr( fname );
        if ( (f = fopen(fname,FOPWA)) == NULL )
        {
            fprintf( stderr, "Cannot create file %s: %s\a\n", fname, sDescr );
            *fname = '\0' ;
            *ok2open = FALSE ;
            return( NULL );
        }
        fprintf( stderr, "Creating %-12s %s\n", fname, sDescr );
        return( f );
    }
    return( NULL );
}


int qs_compare( const void *arg1, const void *arg2 )
{
    return( strcmp( (char *)arg1, (char *)arg2 ) );
}


void    cus_heading( void )                     //~~~
{
    int         x ;
    char        *title ;

    LOOP( x, 0, 30, 1 )
    {
        if ( tblCusFld[x] == NULL )
            tblCusHdr[x] = NULL ;
        else
            tblCusHdr[x] = strdup( tblCusFld[x] );
    }

    x = 0 ;
    while ( tblCusFld[x] != NULL )              // line 1 of title
    {
        if ( st_eq(tblCusFld[x], tblField[1]) )
            fprintf( fCus, "%-*.*s ", iCusNameSiz, iCusNameSiz, "User Name" );
        if ( st_eq(tblCusFld[x], tblField[8]) )
            fprintf( fCus, "%-*.*s ", iCusClassSiz, iCusClassSiz, "Class" );
        if ( st_eq(tblCusFld[x], tblField[9]) )
            fprintf( fCus, "%-*.*s ", iCusPhoneSiz, iCusPhoneSiz, "Phone" );
        if ( st_eq(tblCusFld[x], tblField[2]) ) // birth date
        {
            if ( iCusBDateSiz == 7 )  title = "BirthDt";     else
            if ( iCusBDateSiz == 8 )  title = "Birth Dt";    else
            if ( iCusBDateSiz == 9 )  title = "BirthDate";   else
                                      title = "Birth Date";
            fprintf( fCus, "%-*.*s ", iCusBDateSiz, iCusBDateSiz, title );
        }
        if ( st_eq(tblCusFld[x], tblField[4]) ) // creation date
        {
            if ( iCusCDateSiz == 7 )  title = "FirstCl";     else
            if ( iCusCDateSiz == 8 )  title = "FirstCal";    else
            if ( iCusCDateSiz == 9 )  title = "FirstCall";   else
                                      title = "First Call";
            fprintf( fCus, "%-*.*s ", iCusCDateSiz, iCusCDateSiz, title );
        }
        if ( st_eq(tblCusFld[x], tblField[6]) ) // last login
        {
            if ( iCusLDateSiz == 7 )  title = "LasCall";     else
            if ( iCusLDateSiz == 8 )  title = "LastCall";    else
                                      title = "Last Call";
            fprintf( fCus, "%-*.*s ", iCusLDateSiz, iCusLDateSiz, title );
        }
        if ( st_eq(tblCusFld[x], tblField[3]) )
            fprintf( fCus, "%-*.*s ", iCusAgeSiz, iCusAgeSiz, "Age" );
        if ( st_eq(tblCusFld[x], tblField[5]) )
        {
            if ( iCusCDaysSiz <  8 )  title = "Created";     else
            if ( iCusCDaysSiz == 8 )  title = "createDt";    else
            if ( iCusCDaysSiz == 9 )  title = "CreatedOn";   else
                                      title = "Created On";
            fprintf( fCus, "%-*.*s ", iCusCDaysSiz, iCusCDaysSiz, title );
        }
        if ( st_eq(tblCusFld[x], tblField[7]) )
        {
            if ( iCusLDaysSiz <  7 )  title = "Login";       else
            if ( iCusLDaysSiz == 7 )  title = "LsLogin";     else
            if ( iCusLDaysSiz == 8 )  title = "LoggedIn";    else
            if ( iCusLDaysSiz == 9 )  title = "LastLogin";   else
                                      title = "Last Login";
            fprintf( fCus, "%-*.*s ", iCusLDaysSiz, iCusLDaysSiz, title );
        }
        x++ ;
    }
    fprintf( fCus, "\n" );

    x = 0 ;
    while ( tblCusFld[x] != NULL )              // line 2 of title
    {
        if ( st_eq(tblCusFld[x], tblField[1]) )
            fprintf( fCus, "%-*.*s ", iCusNameSiz, iCusNameSiz, line );
        if ( st_eq(tblCusFld[x], tblField[2]) )
            fprintf( fCus, "%-*.*s ", iCusBDateSiz, iCusBDateSiz, line );
        if ( st_eq(tblCusFld[x], tblField[3]) )
            fprintf( fCus, "%-*.*s ", iCusAgeSiz, iCusAgeSiz, line );
        if ( st_eq(tblCusFld[x], tblField[4]) )
            fprintf( fCus, "%-*.*s ", iCusCDateSiz, iCusCDateSiz, line );
        if ( st_eq(tblCusFld[x], tblField[5]) )
            fprintf( fCus, "%-*.*s ", iCusCDaysSiz, iCusCDaysSiz, line );
        if ( st_eq(tblCusFld[x], tblField[6]) )
            fprintf( fCus, "%-*.*s ", iCusLDateSiz, iCusLDateSiz, line );
        if ( st_eq(tblCusFld[x], tblField[7]) )
            fprintf( fCus, "%-*.*s ", iCusLDaysSiz, iCusLDaysSiz, line );
        if ( st_eq(tblCusFld[x], tblField[8]) )
            fprintf( fCus, "%-*.*s ", iCusClassSiz, iCusClassSiz, line );
        if ( st_eq(tblCusFld[x], tblField[9]) )
            fprintf( fCus, "%-*.*s ", iCusPhoneSiz, iCusPhoneSiz, line );
        x++ ;
    }
    fprintf( fCus, "\n" );
}


void    cus_report( struct usracc *u )          //~~~ Custom report
{
//  Add fields to custom report:                //~~~
//  address(1-4)
//  phone .......... fprintf( fDet, "Phone: %s\n", u->usrpho );
//  protected
//  tagged for kill
//  suspended
//  master key

    static char username[81], dbuf[11] ;
    static long lFirstSignOn, lLastSignOn, bd, cd, ud ;
    static int  iUserForDays, iDaysSinceLastLogin, x ;
    static BOOL ynFirst=TRUE ;

    if ( ynFirst )
        cus_heading();
                                        bd = dt_decode_str( u->birthd );
    strcpy( dbuf, ncdate(u->credat) );  cd = dt_decode_str( dbuf );
    strcpy( dbuf, ncdate(u->usedat) );  ud = dt_decode_str( dbuf );

    FormatDate( bd, dt1, iCusBDateFmt );
    FormatDate( cd, dt2, iCusCDateFmt );
    FormatDate( ud, dt3, iCusLDateFmt );

    lFirstSignOn = cofdat( u->credat );
    lLastSignOn  = cofdat( u->usedat );
    iUserForDays        = (int) (today_days - lFirstSignOn) ;
    iDaysSinceLastLogin = (int) (today_days - lLastSignOn ) ;

    strcpy ( username, u->userid );             // userid by default
    switch ( iCusNameFmt )
    {
        case 2 :
            strcpy( username, u->usrnam );
            break ;
        case 3 :
            if ( ! st_eq(u->usrnam, u->userid) )
                sprintf( username, "%s [%s]", u->usrnam, u->userid );
            break ;
        case 4 :
            if ( ! st_eq(u->usrnam, u->userid) )
                sprintf( username, "%s [%s]", u->userid, u->usrnam );
    }

    x = 0 ;
    while ( tblCusFld[x] != NULL )              // print fields in desired sequence
    {
//      text data
        if ( st_eq(tblCusFld[x], tblField[1]) )
            fprintf( fCus, "%-*.*s ", iCusNameSiz, iCusNameSiz, username );
        if ( st_eq(tblCusFld[x], tblField[8]) )
            fprintf( fCus, "%-*.*s ", iCusClassSiz, iCusClassSiz, u->curcls );
        if ( st_eq(tblCusFld[x], tblField[9]) )
            fprintf( fCus, "%-*.*s ", iCusPhoneSiz, iCusPhoneSiz, u->usrpho );

//      dates
        if ( st_eq(tblCusFld[x], tblField[2]) )
            fprintf( fCus, "%-*.*s ", iCusBDateSiz, iCusBDateSiz, dt1 );
        if ( st_eq(tblCusFld[x], tblField[4]) )
            fprintf( fCus, "%-*.*s ", iCusCDateSiz, iCusCDateSiz, dt2 );
        if ( st_eq(tblCusFld[x], tblField[6]) )
            fprintf( fCus, "%-*.*s ", iCusLDateSiz, iCusLDateSiz, dt3 );

//      numeric data
        if ( st_eq(tblCusFld[x], tblField[3]) )
        {
            if ( age == ERROR )
                fprintf( fCus, "%-*.*s ", iCusAgeSiz, iCusAgeSiz, sAge );
            else
                fprintf( fCus, "%*d ", iCusAgeSiz, age );
        }
        if ( st_eq(tblCusFld[x], tblField[5]) )
            fprintf( fCus, "%*d ", iCusCDaysSiz, iUserForDays );
        if ( st_eq(tblCusFld[x], tblField[7]) )
            fprintf( fCus, "%*d ", iCusLDaysSiz, iDaysSinceLastLogin );

        x++ ;
    }

    fprintf( fCus, "\n" );
    ynFirst = FALSE ;
}


void    std_report( struct usracc *u )          //~~~ Std report
{
    static char username[81], dbuf[11] ;
    static long lFirstSignOn, lLastSignOn, bd, cd, ud ;
    static int  iUserForDays, iDaysSinceLastLogin ;
    static BOOL ynFirst=TRUE ;

    if ( ynFirst )
        fprintf( fStd, "User                          Born      Age User since/days Last login/days ago Class\n"
                       "----------------------------- --------- --- --------------- ------------------- ---------------\n" );

                                        bd = dt_decode_str( u->birthd );
    strcpy( dbuf, ncdate(u->credat) );  cd = dt_decode_str( dbuf );
    strcpy( dbuf, ncdate(u->usedat) );  ud = dt_decode_str( dbuf );

    FormatDate( bd, dt1, iRepDateFmt );
    FormatDate( cd, dt2, iRepDateFmt );
    FormatDate( ud, dt3, iRepDateFmt );

    lFirstSignOn = cofdat( u->credat );
    lLastSignOn  = cofdat( u->usedat );
    iUserForDays        = (int) (today_days - lFirstSignOn) ;
    iDaysSinceLastLogin = (int) (today_days - lLastSignOn ) ;

    if ( st_eq(u->usrnam, u->userid) )
        strcpy( username, u->userid );
    else
        sprintf( username, "%s [%s]", u->userid, u->usrnam );

    fprintf( fStd, "%-*.*s %s %s %s %5d %s %9d %s\n",
             szUNAME, szUNAME, username, dt1, sAge, dt2, iUserForDays,
             dt3, iDaysSinceLastLogin, u->curcls );

    ynFirst = FALSE ;
}


void    pur_report( struct usracc *u )          //~~~ Purge report
{
    static char username[81], dbuf[11] ;
    static long lLastSignOn, cd, ud ;
    static int  iDaysSinceLastLogin ;
    static BOOL ynFirst=TRUE ;

    if ( ynFirst )
    {
        fprintf( fPur, "Users Eligible for Removal" );
        if ( strlen(sPurClass) )
            fprintf( fPur, " from Class %s", sPurClass );
        fprintf( fPur, "\n\nDate login Days ago Age Real name [UserID]\n"
                       "---------- -------- --- -------------------------------------------------------\n" );
        ynFirst = FALSE ;
    }

    strcpy( dbuf, ncdate(u->credat) );  cd = dt_decode_str( dbuf );
    strcpy( dbuf, ncdate(u->usedat) );  ud = dt_decode_str( dbuf );

    if ( cd != ud )                             // dates must be equal
        return ;

    lLastSignOn  = cofdat( u->usedat );
    iDaysSinceLastLogin = (int) (today_days - lLastSignOn ) ;

    if ( iDaysSinceLastLogin < nPurDays )       // too recent
        return ;

    if ( strlen(sPurClass) )
    {
        if ( ! st_eq(sPurClass, u->curcls) )    // limit to single class
            return ;
    }

    if ( (u->flags & UNDAXS) || (u->flags & DELTAG) ) // protected or already
        return ;                                      // marked for deletion

    FormatDate( ud, dt3, iRepDateFmt );

    if ( st_eq(u->usrnam, u->userid) )
        strcpy( username, u->userid );
    else
        sprintf( username, "%s [%s]", u->usrnam, u->userid );

    if ( u->flags & HASMST )
        ST_CAT( username, " (MASTER)" );
    if ( u->flags & SUSPEN )
        ST_CAT( username, " (SUSPENDED)" );
    if ( u->flags & GOINVB )
        ST_CAT( username, " (INVISIBLE)" );

    fprintf( fPur, "%10.10s %8d %3s %s\n",
                   dt3, iDaysSinceLastLogin, sAge, username );

    nPurTotal ++ ;

#if 0
Report: Eligible for Purge

[purge]
days=14
class=user
showprotected=no

With a user-defined # of days, if date created = date of last logon, and it's
been longer than "days", show them on this report.  Allow to restrict to a
single class.  Obey protected status...


Date login Days ago Age Real name [UserID]
---------- -------- --- -----------------------------
29-Mar-95        24  13 Joe Ng [Bloodfist]
17-Mar-95        36  79 Dave Sheffield
30-Mar-95        23  23 Trevor Blasco
28-Mar-95        25  17 Zane Shulko
#endif
}


void    csv_report( struct usracc *u )          //~~~ CSV
{
    static long bd, cd, ud ;
    static char dbuf[11] ;
                                        bd = dt_decode_str( u->birthd );
    strcpy( dbuf, ncdate(u->credat) );  cd = dt_decode_str( dbuf );
    strcpy( dbuf, ncdate(u->usedat) );  ud = dt_decode_str( dbuf );

    FormatDate( bd, dt1, iCsvDateFmt );
    FormatDate( cd, dt2, iCsvDateFmt );
    FormatDate( ud, dt3, iCsvDateFmt );

    fprintf( fCsv, "\"%s\", \"%s\", \"%d\", \"%s\", \"%s\", \"%s\"\n",
             u->usrnam, dt1, age, dt2, dt3, u->curcls );
}


void    add_person( STRING pStr )
{
    if ( person_end < MAXFOLKS )
    {
        if ( strlen(pStr) )
        {
            strcpy( person[person_end], pStr );
            person_end += 1 ;
        }
    }
    else
    {
        fprintf( stderr, "\nMore than %d entries in the list: %s\n", (int) MAXFOLKS, pStr );
    }
}


void    bdt_report( struct usracc *u )          //~~~ birth dates
{
    static char username[81] ;
    static long bd ;

    if ( nextbd < (look_next+1) || prevbd < (look_prev+1) ) // in range?
    {
        bd = dt_decode_str( u->birthd );
        FormatDate( bd, dt3, 10 );
        if ( st_eq(u->usrnam, u->userid) )
            strcpy( username, u->userid );
        else
            sprintf( username, "%s (%s)", u->userid, u->usrnam );

        if ( nextbd == 0 )
            strcpy( dt3, "Today" );
        else
        if ( nextbd == 1 )
            strcpy( dt3, "Tomorrow" );
        else
        if ( prevbd == 1 )
            strcpy( dt3, "Yesterday" );

        sprintf( one_person, "%04d%-17s %-12.12s %s",
                 moda2, nextbd==0 ? "Happy Birthday!" : "", dt3, username );
        add_person( one_person );
    }
}


void    det_report( struct usracc *u, struct bbsgen *gen ) //~~~ detail report
{
    fprintf( fDet, "UserID   : %s\n", u->userid );
    if ( ynPassword )
        fprintf( fDet, "Password : %s\n", u->psword );
    fprintf( fDet, "Real Name: %s\n", u->usrnam );
    fprintf( fDet, "Born     : %s\n", u->birthd );
    fprintf( fDet, "Age      : %d\n", (int) u->age );
    fprintf( fDet, "Sex      : %s\n", (u->sex == 'M' ? "Male" : "Female") );
    fprintf( fDet, "Address 1: %s\n", u->usrad1 );
    fprintf( fDet, "Address 2: %s\n", u->usrad2 );
    fprintf( fDet, "Address 3: %s\n", u->usrad3 );
    fprintf( fDet, "Address 4: %s\n", u->usrad4 );
    fprintf( fDet, "Phone    : %s\n", u->usrpho );
    fprintf( fDet, "Language : %s\n", gen->lngnam[0] != '\0' ? gen->lngnam : "<not selected>" );
    fprintf( fDet, "Computer : %d%s\n", u->systyp, ((u->ansifl&ANSON) ? " (ANSI)" : "") );
    fprintf( fDet, "CRT      : %2dx%2d\n", u->scnwid, u->scnbrk );
    fprintf( fDet, "Df Editor: %s\n", (u->usrprf&PRFLIN) ? "LINE" : "FSE" );
    fprintf( fDet, "Class    : %s\n", u->curcls );
    fprintf( fDet, "In Class : %d\n", u->daystt );
    if ( ynCreditInfo )
    {
        fprintf( fDet, "Cred Avl : %ld\n", u->creds );
        fprintf( fDet, "Cred Ever: %ld\n", u->totcreds );
        fprintf( fDet, "Cred Paid: %ld\n", u->totpaid );
    }
    fprintf( fDet, "Created  : %s\n", ncedat(u->credat) );
    fprintf( fDet, "Last Used: %s\n", ncedat(u->usedat) );

    fprintf( fDet, "MasterKey: %s\n", u->flags&HASMST ? "Yes" : "No" );
    fprintf( fDet, "Protected: %s\n", u->flags&UNDAXS ? "Yes" : "No" );
    fprintf( fDet, "Suspended: %s\n", u->flags&SUSPEN ? "Yes" : "No" );
    fprintf( fDet, "Kill Tag : %s\n", u->flags&DELTAG ? "Yes" : "No" );
    fprintf( fDet, "Invisible: %s\n", u->flags&GOINVB ? "Yes" : "No" );

    fprintf( fDet, "---------\n" );
}


void    stats_report( void )                    //~~~ statistics
{
//  fprintf( fStat, "Statistics for : %s %s %s\n\n", TodaysDay(), TodaysDate(), TodaysTime() );
    FormatDate( nymd, dt1, iRepDateFmt );
    fprintf( fStat, "Date             : %s\n", dt1 );
    if ( ynCreditInfo )
        fprintf( fStat, "Paying Accounts  : %ld\n", numpai );
    fprintf( fStat, "Total Accounts   : %ld\n", numact );
    fprintf( fStat, "Male Accounts    : %ld\n", numale );
    fprintf( fStat, "Female Accounts  : %ld\n", numfem );
    if ( ynCreditInfo )
        fprintf( fStat, "Total Credits    : %ld\n", useavl );

    fprintf( fStat, "\nMaster Key       : %ld\n", numMaster  );
    fprintf( fStat, "Protected        : %ld\n", numProt    );
    fprintf( fStat, "Suspended        : %ld\n", numSusp    );
    fprintf( fStat, "Tagged for Kill  : %ld\n", numKillTag );
    fprintf( fStat, "Invisible @ Logon: %ld\n", numInvis   );
}


void    init_custom_report_table( void )
{
    int x, lowest ;
    char *pWhich ;

    LOOP( x, 0, 30, 1 )
    {
        tblCusFld[x] = NULL ;
    }
    x = 0 ;

    while ( (rnCusName + rnCusBirth + rnCusAge + rnCusCrDate + rnCusCrDays + rnCusLgDate + rnCusLgDays + rnCusClass + rnCusPhone) )
    {
        lowest = 9999 ;
        pWhich = tblField[0] ;
        if ( rnCusName )
        {
            if ( rnCusName < lowest )
            {
                lowest = rnCusName ;
                pWhich = tblField[1] ;
            }
        }
        if ( rnCusBirth )
        {
            if ( rnCusBirth < lowest )
            {
                lowest = rnCusBirth ;
                pWhich = tblField[2] ;
            }
        }
        if ( rnCusAge )
        {
            if ( rnCusAge < lowest )
            {
                lowest = rnCusAge ;
                pWhich = tblField[3] ;
            }
        }
        if ( rnCusCrDate )
        {
            if ( rnCusCrDate < lowest )
            {
                lowest = rnCusCrDate ;
                pWhich = tblField[4] ;
            }
        }
        if ( rnCusCrDays )
        {
            if ( rnCusCrDays < lowest )
            {
                lowest = rnCusCrDays ;
                pWhich = tblField[5] ;
            }
        }
        if ( rnCusLgDate )
        {
            if ( rnCusLgDate < lowest )
            {
                lowest = rnCusLgDate ;
                pWhich = tblField[6] ;
            }
        }
        if ( rnCusLgDays )
        {
            if ( rnCusLgDays < lowest )
            {
                lowest = rnCusLgDays ;
                pWhich = tblField[7] ;
            }
        }
        if ( rnCusClass )
        {
            if ( rnCusClass < lowest )
            {
                lowest = rnCusClass ;
                pWhich = tblField[8] ;
            }
        }
        if ( rnCusPhone )
        {
            if ( rnCusPhone < lowest )
            {
                lowest = rnCusPhone ;
                pWhich = tblField[9] ;
            }
        }
        if ( lowest < 9999 )
        {
            if ( st_eq(pWhich, "name") )
                rnCusName = 0 ;
            if ( st_eq(pWhich, "birth") )
                rnCusBirth = 0 ;
            if ( st_eq(pWhich, "age") )
                rnCusAge = 0 ;
            if ( st_eq(pWhich, "crdate") )
                rnCusCrDate = 0 ;
            if ( st_eq(pWhich, "crdays") )
                rnCusCrDays = 0 ;
            if ( st_eq(pWhich, "lgdate") )
                rnCusLgDate = 0 ;
            if ( st_eq(pWhich, "lgdays") )
                rnCusLgDays = 0 ;
            if ( st_eq(pWhich, "class") )
                rnCusClass = 0 ;
            if ( st_eq(pWhich, "phone") )
                rnCusPhone = 0 ;

            tblCusFld[x] = strdup( pWhich );
            x++ ;
        }
    }
}


void    main_init( int argc, char *argv[] )
{
    char        *p ;

    strcpy( repStd, argv[0] );                  // get .INI name from .EXE name
    p = strrchr( repStd, '.' );
    *p = EOS ;
    sprintf( iniName, "%s.ini", repStd );
    if ( argc > 1 )
        strcpy( iniName, argv[1] );             // user supplied .INI name
    strupr( iniName );

    fprintf( stderr, "\r%-74s%s\nCopyright %s by GeCe Ventures, "
                     "all rights reserved.\n%79.79s\n",
                     pgTITL_, pgVERS_, pgCOPR_, Line );
    fprintf( stderr, "Processing with options set in %s\n", iniName );

    parse_ini_file();                           // get parameters from .ini
    init_custom_report_table();

    dt_getsystemdate( &nymd, &ny, &nm, &nd );
    moda1 = nm*100 + nd ;                       // just month/day
    this_year = ny * 10000L ;                   // this year + 0000
    next_year = this_year + 10000L ;            // next year + 0000

    today_days = cofdat( today() );

    btvUsr = opnbtv( "bbsusr.dat", sizeof(struct usracc) );
    genbb  = opnbtv( "bbsgen.dat", GENSIZ );
    setbtv( btvUsr );
    if ( ! qlobtv(0) )
         catastro( "User account file is empty!" );

    fCus  = open_file( &ynRepCus  , fCus , repCus   ,"Custom Report" );
    fStd  = open_file( &ynRepStd  , fStd , repStd   ,"Standard Report" );
    fDet  = open_file( &ynRepDet  , fDet , repDet   ,"Detailed Report" );
    fCsv  = open_file( &ynRepCsv  , fCsv , repCsv   ,"CSV file" );
    fBdt  = open_file( &ynRepBdt  , fBdt , repBdt   ,"Birthday Announcements" );
    fPur  = open_file( &ynRepPurge, fPur , repPurge ,"Eligible for Purge" );
    fStat = open_file( &ynRepStats, fStat, repStats ,"Statistics" );
}


void    main( int argc, char *argv[] )          //~~~ main
{
    BOOL        ynFirst=TRUE ;

    main_init( argc, argv );

    do {
        gcrbtv( &acct, 0 );
        getgen( &genbuf, acct.userid );

        age = dt_calculate_age( acct.birthd, sAge, &prevbd, &nextbd );

        ynProcess = TRUE ;                      // by default process everyone
        if ( strlen(sClassGenExclude) || strlen(sClassGenInclude) )
        {
            if ( strlen(sClassGenExclude) )
            {
                if ( st_eq(sClassGenExclude, acct.curcls) )
                    ynProcess = FALSE ;         // exclude this class
            }
            if ( strlen(sClassGenInclude) )
            {
                if ( ! st_eq(sClassGenInclude, acct.curcls) )
                    ynProcess = FALSE ;         // limit to single class
            }
        }

        if ( ynProcess )
        {
            show_activity( numact++, 5 );
            if ( ynRepDet )
                det_report( &acct, &genbuf );
            if ( ynRepCus )
                cus_report( &acct );
            if ( ynRepStd )
                std_report( &acct );
            if ( ynRepCsv )
                csv_report( &acct );
            if ( ynRepBdt )
                bdt_report( &acct );
            if ( ynRepPurge )
                pur_report( &acct );
            if ( ynRepStats )
            {
                if ( acct.sex == 'M' )
                    numale++ ;
                else
                    numfem++ ;
                if ( acct.totpaid != 0L )
                    numpai++ ;
                useavl += acct.creds ;
                if ( acct.flags & HASMST )
                    numMaster ++ ;
                if ( acct.flags & UNDAXS )
                    numProt ++ ;
                if ( acct.flags & SUSPEN )
                    numSusp ++ ;
                if ( acct.flags & DELTAG )
                    numKillTag ++ ;
                if ( acct.flags & GOINVB )
                    numInvis ++ ;
            }
        }
    }   while (qnxbtv());

    clsbtv( genbb );
    clsbtv( btvUsr );

    fprintf( stderr, "\r%ld records\n", numact );

    if ( ynRepCus )
        fprintf( fCus, "\nTotal %ld users\n", numact );

    if ( ynRepPurge )                           // close off purge report
    {
        if ( nPurTotal > 0 )
        {
            fprintf( fPur, "\n%d user%sn't called back since signing up more than %d days ago,\n"
                           "and should be considered for removal.\n",
                           nPurTotal, nPurTotal==1 ? " has" : "s have", nPurDays );
        }
        else
            fprintf( fPur, "\nNo users are to be considered for removal at this time.\n" );
    }

    if ( ynRepBdt )                             // do birthdays?
    {
        if ( person_end > 0 )
        {
            if ( ynSort )
                qsort( (void *)person,
                       (size_t)person_end,
                       (size_t)sizeof(person[0]),
                       qs_compare );

            for ( this_person = 0 ; this_person<person_end ; this_person++ )
            {
                strcpy( one_person, person[this_person] );
                if ( ynFirst )
                {
                    if ( ynBDcls )
                        fprintf( fBdt, "%s\033[2J", ansiColor );
                    fprintf( fBdt, "%s%-18s%-13s%s%s\n",
                                   (ynANSI ? ansiColor : ""),
                                   "Birthdays:", "When", "Who",
                                   (ynANSI ? ansiClrEol : "") );
                    fprintf( fBdt, "%18s%12.12s %48.48s%s\n", "", Line, Line,
                                   (ynANSI ? ansiClrEol : "") );
                }

                if ( ynANSI )
                {
                    st_cpy( BD1, &one_person[ 4], 10 );
                    st_cpy( BD2, &one_person[22], 13 );
                    st_cpy( BD3, &one_person[35], 49 );
                    st_trim( BD1 );
                    st_trim( BD2 );
                    st_trim( BD3 );
                    if ( strlen(BD1) )
                        fprintf( fBdt, "%s Happy Birthday! %s ", ansiBDhappyColor, ansiColor );
                    else
                        fprintf( fBdt, "%s%18s", ansiColor, "" );
                    fprintf( fBdt, "%s%-12.12s%s %s%-48.48s%s%s\n",
                                   ansiBDdateColor, BD2, ansiColor,
                                   ansiBDnameColor, BD3, ansiColor, ansiClrEol );
                }
                else
                    fprintf( fBdt, "%s\n", &one_person[4] );

                ynFirst = FALSE ;
            }
            if ( ! ynFirst )
            {
                fprintf( fBdt, "%18s%12.12s %48.48s%s\n%s", "", Line, Line,
                               (ynANSI ? ansiClrEol : ""), (ynANSI ? ansiReset : "") );
            }
        }
    }

    if ( ynRepStats )
        stats_report();

    closing_comments();
    fcloseall();
    exit( 0 );
}
